=== l4/pkg/l4sys/Makefile ===
PKGDIR	= .
L4DIR	?= $(PKGDIR)/../..

TARGET = include lib doc

include $(L4DIR)/mk/subdir.mk
